unit main;
{$ifdef FPC}{$mode objfpc}{$h+}{$endif}

interface

uses
 mseglob,mseguiglob,mseguiintf,mseapplication,msestat,msemenus,msegui,
 msegraphics,msegraphutils,mseevent,mseclasses,mseforms,math,msetypes,mseedit,
 msestrings,msedataedits,msesimplewidgets,msewidgets,mserealsumedit,
 msegraphedits,msegrids,mseact,mseactions,mseifiglob,msetimer,msedispwidgets;


const
// exess_coeff = 2;
 exess_coeff_mul: float = 100/99;
// check_coeff = 10; 

type

 progresscallbackprocty = procedure(const cur_pct: integer);
 floatarty = array of float;

 tmainfo = class(tmainform)
   btnExit: tbutton;
   tgroupbox1: tgroupbox;
   ieSamplesN: tintegeredit;
   gbMean: tgroupbox;
   reMeanValue: trealsumedit;
   reMeanPrec: trealsumedit;
   gbSDtdDev: tgroupbox;
   reStdDevPrec: trealsumedit;
   reStdDevValue: trealsumedit;
   gbTrust: tgroupbox;
   reTrustMin: trealsumedit;
   reTrustMax: trealsumedit;
   gbFormat: tgroupbox;
   breFmtFloat: tbooleaneditradio;
   breFmtInteger: tbooleaneditradio;
   gbResults: tgroupbox;
   sgResults: tstringgrid;
   btnGo: tbutton;
   btnClear: tbutton;
   actClear: taction;
   tlabel1: tlabel;
   tlabel2: tlabel;
   tbutton2: tbutton;
   actCopy: taction;
   ieTimer: tintegeredit;
   tlabel3: tlabel;
   tlabel4: tlabel;
   rdMean: trealdisp;
   rdStdDev: trealdisp;
   procedure calcexec;
   procedure copyexec(const sender: TObject);
   procedure trustsetvalue(const sender: TObject; var avalue: realty;
                   var accept: Boolean);
   procedure notlongettimed(const sender: TObject);
   procedure closequery(const sender: tcustommseform;
                   var amodalresult: modalresultty);
   procedure clearexec(const sender: TObject);
   
   procedure initdatagen(const n_exess: float);
   function getoutdata(const n_passes: qword; var success: boolean;progresscallbackproc: progresscallbackprocty = nil): floatarty;
   
 end;

var
	mainfo: tmainfo;

//-------------------

implementation

uses
	main_mfm,
	msereal,
	mseformatstr,
	msesysutils;

var
	// массив "грязных" данных 
	a_exess_samples: floatarty;
	// и его размер
	n_exess_samples: integer;
	// и текущий заход по увеличению объема "грязных" данных	
	exess_try_n: integer;

	// текущий заход по очистке "грязных" данных
	check_try_n: integer;
	

	// то, что ввел пользователь
	mean_in: float;
	stddev_in: float;
	n_samples_in:integer;
	min_in: float;
	max_in: float;
	mean_prec_in: float;
	stddev_prec_in: float;

	last_mean,last_stddev: float;

//---------------------

function fact_div(const a_more,a_fewer: cardinal):qword;
var
	i: integer;
begin
	result:= 1;
	if a_more = a_fewer then exit; 
	for i:= (a_more - a_fewer + 1) to a_more do begin
		result:= result * i;
	end;	
	// поправка (=MAX_QWORD) на переполнение QWORD-типа
	if result = 0 then result:= 18446744073709551615;
end;


function opentodynarrayf(const items: array of float): floatarty;
var
 int1: integer;
begin
 setlength(result,length(items));
 for int1:= 0 to high(items) do begin
  result[int1]:= items[int1];
 end;
end;


procedure tmainfo.initdatagen(const n_exess: float);
var
	f1: float;
	i:integer;
	int_values: boolean;
	f2: float;
begin
	int_values:= breFmtFloat.checkedtag <> 0;
f2:= 	n_samples_in;
	n_exess_samples:= ceil(f2*n_exess);
	setlength(a_exess_samples,n_exess_samples);
	i:= 0;
	while i < n_exess_samples do begin
		// очередное гауссово число
		f1:= randg(mean_in,stddev_in);	
		// пропускаем только доверительный интервал значений
		if (f1 >= min_in) and (f1 <= max_in) then begin
//			if int_values and (f1 <> int(f1)) then continue;
			if int_values then f1:= int(f1);
			a_exess_samples[i]:= f1;
			i:= i + 1;
		end;
	end;
end;

//---------------------

function tmainfo.getoutdata(
	const n_passes: qword; 
	var success: boolean;
	progresscallbackproc: progresscallbackprocty = nil
): floatarty;
var
//	pct,old_pct: integer;
	i,j: integer;
//	mf,sf: float;
begin
//	old_pct:= 0;
	success:= false;
	

	for j:=0 to n_passes do begin
	
//		if (j > 0) and ( floor(j*100/n_passes) mod 10 = 0) then begin
//			pct:= floor(j*100/n_passes);
//			if pct > old_pct then begin
//				old_pct:= pct;
//				if progresscallbackproc <> nil then progresscallbackproc(pct);
//			end;
//		end;

		// получение пробы выходных данных через прореживание избыточной выборки
		// по случайным индексам
		setlength(result,n_samples_in);
		i:= 0;
		//  randomize;
//		for i:= 0 to n_samples_in - 1 do result[i]:= formatfloatmse(a_exess_samples[random(n_exess_samples-1)],'0.###f');
		for i:= 0 to n_samples_in - 1 do result[i]:= a_exess_samples[random(n_exess_samples-1)];
		// проверка пробы выходных данных 
		meanandstddev(result,last_mean,last_stddev);
		// попадаем в заданные параметры - выходим с последним результатом
		if (abs(last_mean-mean_in) <= mean_prec_in) and (abs(last_stddev-stddev_in) <= stddev_prec_in) then begin
			success:= true;
			exit;
		end;	
		setlength(result,0);		
		result:= nil;
	end;
end;
		
//---------------------


procedure tmainfo.calcexec;
var
	data_ready: boolean;
	i: integer;
	a_out: floatarty; 
	ts: longword;
	n_attempts: qword;
	n1: float;
begin
//  if mainfo.canparentclose then begin
	exess_try_n:= 1;
	check_try_n:= 1;

	n_samples_in:= ieSamplesN.value;
	min_in:= reTrustMin.value;
	max_in:= reTrustMax.value; 
	mean_in:= reMeanValue.value;
	stddev_in:= reStdDevValue.value;
	mean_prec_in:= mean_in*reMeanPrec.value/100;
	stddev_prec_in:= stddev_in*reStdDevPrec.value/100; 

	if max_in < mean_in then begin
		showmessage('Максимум доверительного интервала не должен быть мешьше средне-арифметического значения!');
		exit;
	end else if min_in > mean_in then begin
		showmessage('Минимум доверительного интервала не должен быть больше средне-арифметического значения!');
		exit;
	end;

	sgResults.clear;

//	notlonger_elapsed:= false;
//	tmrNotLonger.interval:= -ieTimer.value*1000000;
//	tmrNotLonger.enabled:= true;

	randomize;
	ts:= timestep(ieTimer.value*1000000);
	n1:= 1.0;
	repeat

		// делаем "грязную" выборку
//		initdatagen(ceil(power(exess_coeff,exess_try_n)));
//      SQRT _ чтобы медленне росло при увеличении 
		n1:= sqrt(n1*exess_coeff_mul);
		initdatagen(n1);

		// с каждым неуспехом (в очистке) увеличивая в "exess_try_n" ее размер
//		inc(exess_try_n);
		// пытаемся выполнить очистку "check_coeff*n_exess_samples" раз,
		// пока не получим чистую выборку
		n_attempts:= ceil(fact_div(n_exess_samples,n_exess_samples-n_samples_in)/n_samples_in);
		// на переполнении числа вариантов - выход
		if n_attempts = 0 then break;
//		a_out:= getoutdata(check_coeff*n_exess_samples,data_ready,nil);
		a_out:= getoutdata(n_attempts,data_ready,nil);
	until data_ready or timeout(ts);

	if not data_ready then
		showmessage(
			'Для текущих входных данных за заданное время симуляция не удалась.' + lineend + 
			'Увеличьте погрешности и/или расширьте доверительный интервал, и затем повторите попытку.' + lineend +
			'Иногда нужно найти оптимальное количество отсчетов - ' +lineend + 
			'либо увеличить (единицы => недостаточно статистики),' + lineend + 
			'либо наоборот уменьшить (сотни => невозможно взять расчетный запас по статистике).' + lineend +
			'Также, целочисленные отсчеты намного труднее симулировать.',
			'ПОПЫТКА СИМУЛЯЦИИ НЕ УДАЛАСЬ'
		)
	else begin
		for i:=0 to high(a_out) do begin
			if breFmtFloat.checkedtag = 0 then
				sgResults.appendrow([formatfloatmse(a_out[i],'0.###F')])
			else
				sgResults.appendrow([formatfloatmse(a_out[i],'0')]);
		end;
		setlength(a_out,0);
		rdMean.value:= last_mean;
		rdStdDev.value:= last_stddev;
	end;
//  end;	
end;

//-------------------------------------

procedure tmainfo.copyexec(const sender: TObject);
var
	gc: gridcoordty;
	rc: gridrectty;
begin

// gridrectty = record
//  case integer of
//   0:(
//    col,row: integer;
//    colcount,rowcount: integer;
//   );
//   1:(
//    pos: gridcoordty;
//    size: gridsizety;
//   )
// end;

//There is tcustomstringgrid.copyselection() which copies selected cells from
//columns with co_cancopy set.
//Use tdatacols.setselectedrange() in order to select a block of cells.
// 
//   procedure setselectedrange(const rect: gridrectty; const value: boolean;
//             const calldoselectcell: boolean = false;
//             const checkmultiselect: boolean = false); overload;

//   procedure setselectedrange(const start,stop: gridcoordty;
//                    const value: boolean;
//                    const calldoselectcell: boolean = false;
//                    const checkmultiselect: boolean = false); overload; virtual;
	rc.row:= 0;
	rc.col:= 0;
	rc.rowcount:= sgResults.rowcount;
	rc.colcount:= 1;
	with sgResults,datacols do begin
		setselectedrange(rc,true);
		copyselection;
		clearselection;
	end;
// gridcoordty = record
//  col,row: integer;
// end;
end;

//-------------------------------------

procedure tmainfo.trustsetvalue(const sender: TObject; var avalue: realty;
               var accept: Boolean);
var
	res: boolean;
begin
	if (sender = reTrustMin) and (not isemptyreal(reTrustMax.value)) then 
		accept:= avalue <= reTrustMax.value
 	else if (sender = reTrustMax) and (not isemptyreal(reTrustMin.value)) then
 		accept:= reTrustMin.value <= avalue;
	if not accept then ShowMessage('Верх доверительного интервала должен быть больше низа'); 
end;

procedure tmainfo.notlongettimed(const sender: TObject);
begin
//	notlonger_elapsed:= true;
end;

procedure tmainfo.closequery(const sender: tcustommseform;
               var amodalresult: modalresultty);
begin
	if amodalresult = mr_canclose then begin
		calcexec;
		amodalresult:= mr_none;
	end;
end;

procedure tmainfo.clearexec(const sender: TObject);
begin
	sgResults.clear;
	rdMean.value:= emptyreal;
	rdStdDev.value:= emptyreal;
end;


end.

